//+------------------------------------------------------------------+
//|                                                   Supertrend.mq4 |
//|                   Copyright  2005, Jason Robinson (jnrtrading). |
//|                                      http://www.jnrtrading.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Jason Robinson (jnrtrading)."
#property link      "http://www.jnrtrading.co.uk"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2

extern int CCIPeriod = 36;
extern int ATRPeriod = 4;

double TrendUp[];
double TrendDown[];
double st = 0.0;
bool FirstStart;
string IndicatorName = "Supertrend";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  FirstStart = true;
//---- indicators
   SetIndexBuffer(0, TrendUp);
   SetIndexBuffer(1, TrendDown);
   IndicatorDigits( Digits);
   IndicatorShortName(IndicatorName); 

//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if ( FirstStart ) CreateLabels();   
   int limit, i;
   double cciTrendNow, cciTrendPrevious, rATR;
   double spread = MarketInfo( Symbol(), MODE_SPREAD);
   double ticksize = MarketInfo( Symbol(), MODE_TICKVALUE);
   string InfoText;
   InfoText = "Spread " + DoubleToStr( spread, 0) + " Tickvalue "
             + DoubleToStr( ticksize, 4);
   ObjectSetText( "Info", InfoText, 12, "Arial Rounded MT Bold", LawnGreen);

   int counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) counted_bars--;

   limit=Bars-counted_bars;
   
   cciTrendPrevious = iCCI(NULL, 0, CCIPeriod, PRICE_TYPICAL, limit+1);
   for(i = limit; i >= 0; i--)
   {
      cciTrendNow = iCCI(NULL, 0, CCIPeriod, PRICE_TYPICAL, i);
      rATR = iATR(NULL, 0, ATRPeriod, i);

      if (cciTrendNow >= st)
      {
         if (cciTrendPrevious < st) TrendUp[i+1] = TrendDown[i+1];
         TrendUp[i] = MathMax( TrendUp[i+1], Low[i] - rATR);
         TrendDown[i] = EMPTY_VALUE;
      }
      if (cciTrendNow <= st)
      {
         if ( cciTrendPrevious > st) TrendDown[i+1] = TrendUp[i+1];
         TrendDown[i] = MathMin( TrendDown[i+1], High[i] + rATR);
         TrendUp[i] = EMPTY_VALUE;
      }
      cciTrendPrevious = cciTrendNow;
   }
//----
   return(0);
  }
  
void CreateLabels()
{
   ObjectCreate( "Info", OBJ_LABEL, 0, 0, 0.0);
   ObjectSet( "Info", OBJPROP_CORNER, 1);
   ObjectSet( "Info", OBJPROP_XDISTANCE, 12);
   ObjectSet( "Info", OBJPROP_YDISTANCE, 10); 
   FirstStart = false;
}
//+------------------------------------------------------------------+


